#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Runtime.Serialization;
using HeuristicLab.Common;

namespace HeuristicLab.Services.Hive.Common.DataTransfer {
  [DataContract]
  [Serializable]
  public class Slave : Resource {
    [DataMember]
    public int? Cores { get; set; }
    [DataMember]
    public int? FreeCores { get; set; }
    [DataMember]
    public int? CpuSpeed { get; set; }
    [DataMember]
    public int? Memory { get; set; }
    [DataMember]
    public int? FreeMemory { get; set; }
    [DataMember]
    public SlaveState SlaveState { get; set; }
    [DataMember]
    public CalendarState CalendarSyncState { get; set; }
    [DataMember]
    public Guid? SlaveConfigId { get; set; }
    [DataMember]
    public bool IsAllowedToCalculate { get; set; }

    public Slave() {
      SlaveState = DataTransfer.SlaveState.Idle;
    }
    protected Slave(Slave original, Cloner cloner) : base(original, cloner) {
      this.Cores = original.Cores;
      this.FreeCores = original.FreeCores;
      this.CpuSpeed = original.CpuSpeed;
      this.Memory = original.Memory;
      this.FreeMemory = original.FreeMemory;
      this.SlaveState = original.SlaveState;
      this.CalendarSyncState = original.CalendarSyncState;
      this.SlaveConfigId = original.SlaveConfigId;
      this.IsAllowedToCalculate = original.IsAllowedToCalculate;
    }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new Slave(this, cloner);
    }

    public override string ToString() {
      return string.Format("Cores: {0}, FreeCores: {1}", Cores, FreeCores);
    }
  }
}
